fl

{                       
PropForth 5.5(DevKernel)

Adafruit 32X64 Matrix
2018/06/06 22:12:58


   Adafruit 32X64 Matrix    [ D C B A ]
 -------------------------
| b63   ......         b0 | [ 0 0 0 0 ]      
| upper matrix(16x64)     |    ...        upper matrix(16x64) color[ B1 G1 R1 ]
|                         | [ 1 1 1 1 ]
|-------------------------|
| b63   ......         b0 | [ 0 0 0 0 ]     
| lower matrix(16x64)     |    ...        lower matrix(16x64) color[ B2 G2 R2 ]
|                         | [ 1 1 1 1 ]
 -------------------------
 ^                      ^
output signal side      Input signal side
(LED Matrux side)       (LED Matrux side)

Dot buffer   64Word X 32 = 4096yte 1dot=2byte(16bit)
Using free area( here W@) as matrix buffer
     -------------------------
0   | b63    ......        b0 | <-- 64word(128byte)     
..  | upper matrix(16x64)     |   
16  |                         | 
    |-------------------------|
17  | b63   ......         b0 |     
..  | lower matrix(16x64)     | 
31  |                         | 
     -------------------------
     (LED Matrux side)
     
Address for Matrix
   b63                             b0    [ D C B A ]
 --------------------------------------
|here W@ + 0    Y=0       here W@ + 127| [ 0 0 0 0 ]
|      .                          .    |    ...
|      .      [R0G0B0]            .    |    ...
|here W@ + 1920  Y=16    here W@ + 2047| [ 1 1 1 1 ]
|--------------------------------------|
|here W@ + 2048  Y=17    here W@ + 2175| [ 0 0 0 0 ]
|      .                       .       |    ...
|      .      [R1G1B1]          .      |    ...
|here W@ + 3968  Y=31    here W@ + 4095| [ 1 1 1 1 ]
 --------------------------------------
     

address for Matrix for 8x8 Font 
   b63                             b0    [ D C B A ]
 --------------------------------------
|here W@ + 0    Y=0       here W@ + 127| [ 0 0 0 0 ]
|      .    A-plane               .    |    ...
|      .    [R0G0B0]              .    |    ...
|here W@ + 896  Y=7      here W@ + 1023| [ 0 1 1 1 ]
 --------------------------------------
|here W@ + 1024  Y=8     here W@ + 1151| [ 1 0 0 0 ]
|      .    B-plane               .    |    ...
|      .    [R0G0B0]              .    |    ...
|here W@ + 1920 Y=15     here W@ + 2047| [ 1 1 1 1 ]
 --------------------------------------
|here W@ + 2048 Y=0      here W@ + 2175| [ 0 0 0 0 ]
|      .    C-plane               .    |    ...
|      .    [R1G1B1]              .    |    ...
|here W@ + 2944 Y=7      here W@ + 3071| [ 0 1 1 1 ]
 --------------------------------------
|here W@ + 3072  Y=8     here W@ + 3199| [ 1 0 0 0 ]
|      .    D-plane               .    |    ...
|      .    [R1G1B1]              .    |    ...
|here W@ + 3968 Y=15     here W@ + 4095| [ 1 1 1 1 ]
 --------------------------------------


     
Pulled down[10kohm] from P0 to P5[R1 G1 B1 R2 G2 B2] because of preventing LED-on when 5V power-on     
}

\ =========================================================================== 
\ Variables 
\ =========================================================================== 
\ String buffer(each plane occupy 32byte)
{
StrStruct        string length on A-plane
StrStruct+2      string on A-plane
StrStruct+34     string length on B-plane
StrStruct+36     string on B-plane
StrStruct+68     string length on C-plane
StrStruct+70     string on C-plane
StrStruct+102     string length on D-plane
StrStruct+104    string on D-plane
}
wvariable StrStruct d134 allot

wvariable colorA
wvariable colorB
wvariable colorC
wvariable colorD
wvariable spdA
wvariable spdB
wvariable spdC
wvariable spdD
wvariable sftspdA
wvariable sftspdB
wvariable sftspdC
wvariable sftspdD
wvariable charA
wvariable charB
wvariable charC
wvariable charD
wvariable nA
wvariable nB
wvariable nC
wvariable nD
wvariable currenttNumA
wvariable currenttNumB
wvariable currenttNumC
wvariable currenttNumD

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Pin
0 wconstant R1
\ 1 wconstant G1
\ 2 wconstant B1
3 wconstant R2
\ 4 wconstant G2
\ 5 wconstant B2
6 wconstant LnA
\ 7 wconstant LnB
\ 8 wconstant LnC
\ 9 wconstant LnD
d10 wconstant CLK
d11 wconstant LE
d12 wconstant EN
d126 constant array63

7 R1 lshift invert constant upper_m               \ mask bit for upper-matrix RGB
7 R2 lshift invert constant lower_m               \ mask bit for lower-matrix RGB
hF LnA  lshift invert constant line_m             \ mask bit for line
1 EN lshift constant en_m                         \ EN 
upper_m lower_m and constant plane_m
1 CLK lshift constant clk_m                       \ mask bit for CLK   

\ =========================================================================== 
\ 8X8 Font Characters for OLED
\ =========================================================================== 
wvariable Font -2 allot
h00 c, h00 c, h00 c, h00 c, h00 c, h00 c, h00 c, h00 c,
h00 c, h06 c, h5F c, h5F c, h06 c, h00 c, h00 c, h00 c,
h00 c, h03 c, h07 c, h00 c, h07 c, h03 c, h00 c, h00 c,
h14 c, h7F c, h7F c, h14 c, h7F c, h7F c, h14 c, h00 c,
h24 c, h2E c, h2A c, h6B c, h6B c, h3A c, h12 c, h00 c,
h46 c, h66 c, h30 c, h18 c, h0C c, h66 c, h62 c, h00 c,
h30 c, h7A c, h4F c, h5D c, h37 c, h7A c, h48 c, h00 c,
h00 c, h04 c, h07 c, h03 c, h00 c, h00 c, h00 c, h00 c,
h00 c, h1C c, h3E c, h63 c, h41 c, h00 c, h00 c, h00 c,
h00 c, h41 c, h63 c, h3E c, h1C c, h00 c, h00 c, h00 c,
h08 c, h2A c, h3E c, h1C c, h1C c, h3E c, h2A c, h08 c,
h08 c, h08 c, h3E c, h3E c, h08 c, h08 c, h00 c, h00 c,
h00 c, h80 c, hE0 c, h60 c, h00 c, h00 c, h00 c, h00 c,
h08 c, h08 c, h08 c, h08 c, h08 c, h08 c, h00 c, h00 c,
h00 c, h00 c, h60 c, h60 c, h00 c, h00 c, h00 c, h00 c,
h60 c, h30 c, h18 c, h0C c, h06 c, h03 c, h01 c, h00 c,
h3E c, h7F c, h41 c, h49 c, h41 c, h7F c, h3E c, h00 c,
h40 c, h42 c, h7F c, h7F c, h40 c, h40 c, h00 c, h00 c,
h62 c, h73 c, h59 c, h49 c, h6F c, h66 c, h00 c, h00 c,
h22 c, h63 c, h49 c, h49 c, h7F c, h36 c, h00 c, h00 c,
h18 c, h1C c, h16 c, h53 c, h7F c, h7F c, h50 c, h00 c,
h27 c, h67 c, h45 c, h45 c, h7D c, h39 c, h00 c, h00 c,
h3C c, h7E c, h4B c, h49 c, h79 c, h30 c, h00 c, h00 c,
h03 c, h03 c, h71 c, h79 c, h0F c, h07 c, h00 c, h00 c,
h36 c, h7F c, h49 c, h49 c, h7F c, h36 c, h00 c, h00 c,
h06 c, h4F c, h49 c, h69 c, h3F c, h1E c, h00 c, h00 c,
h00 c, h00 c, h66 c, h66 c, h00 c, h00 c, h00 c, h00 c,
h00 c, h80 c, hE6 c, h66 c, h00 c, h00 c, h00 c, h00 c,
h08 c, h1C c, h36 c, h63 c, h41 c, h00 c, h00 c, h00 c,
h24 c, h24 c, h24 c, h24 c, h24 c, h24 c, h00 c, h00 c,
h00 c, h41 c, h63 c, h36 c, h1C c, h08 c, h00 c, h00 c,
h02 c, h03 c, h51 c, h59 c, h0F c, h06 c, h00 c, h00 c,
h3E c, h7F c, h41 c, h5D c, h5D c, h1F c, h0E c, h00 c,
h7C c, h7E c, h13 c, h13 c, h7E c, h7C c, h00 c, h00 c,
h41 c, h7F c, h7F c, h49 c, h49 c, h7F c, h36 c, h00 c,
h1C c, h3E c, h63 c, h41 c, h41 c, h63 c, h22 c, h00 c,
h41 c, h7F c, h7F c, h41 c, h63 c, h3E c, h1C c, h00 c,
h41 c, h7F c, h7F c, h49 c, h5D c, h41 c, h63 c, h00 c,
h41 c, h7F c, h7F c, h49 c, h1D c, h01 c, h03 c, h00 c,
h1C c, h3E c, h63 c, h41 c, h51 c, h73 c, h72 c, h00 c,
h7F c, h7F c, h08 c, h08 c, h7F c, h7F c, h00 c, h00 c,
h00 c, h41 c, h7F c, h7F c, h41 c, h00 c, h00 c, h00 c,
h30 c, h70 c, h40 c, h41 c, h7F c, h3F c, h01 c, h00 c,
h41 c, h7F c, h7F c, h08 c, h1C c, h77 c, h63 c, h00 c,
h41 c, h7F c, h7F c, h41 c, h40 c, h60 c, h70 c, h00 c,
h7F c, h7F c, h0E c, h1C c, h0E c, h7F c, h7F c, h00 c,
h7F c, h7F c, h06 c, h0C c, h18 c, h7F c, h7F c, h00 c,
h1C c, h3E c, h63 c, h41 c, h63 c, h3E c, h1C c, h00 c,
h41 c, h7F c, h7F c, h49 c, h09 c, h0F c, h06 c, h00 c,
h1E c, h3F c, h21 c, h71 c, h7F c, h5E c, h00 c, h00 c,
h41 c, h7F c, h7F c, h09 c, h19 c, h7F c, h66 c, h00 c,
h26 c, h6F c, h49 c, h49 c, h7B c, h32 c, h00 c, h00 c,
h03 c, h41 c, h7F c, h7F c, h41 c, h03 c, h00 c, h00 c,
h7F c, h7F c, h40 c, h40 c, h7F c, h7F c, h00 c, h00 c,
h1F c, h3F c, h60 c, h60 c, h3F c, h1F c, h00 c, h00 c,
h7F c, h7F c, h30 c, h18 c, h30 c, h7F c, h7F c, h00 c,
h61 c, h73 c, h1E c, h0C c, h1E c, h73 c, h61 c, h00 c,
h07 c, h4F c, h78 c, h78 c, h4F c, h07 c, h00 c, h00 c,
h47 c, h63 c, h71 c, h59 c, h4D c, h67 c, h73 c, h00 c,
h00 c, h7F c, h7F c, h41 c, h41 c, h00 c, h00 c, h00 c,
h01 c, h03 c, h06 c, h0C c, h18 c, h30 c, h60 c, h00 c,
h00 c, h41 c, h41 c, h7F c, h7F c, h00 c, h00 c, h00 c,
h08 c, h0C c, h06 c, h03 c, h06 c, h0C c, h08 c, h00 c,
h80 c, h80 c, h80 c, h80 c, h80 c, h80 c, h80 c, h80 c,
h00 c, h00 c, h01 c, h03 c, h06 c, h04 c, h00 c, h00 c,
h20 c, h74 c, h54 c, h54 c, h3C c, h78 c, h40 c, h00 c,
h41 c, h7F c, h3F c, h48 c, h48 c, h78 c, h30 c, h00 c,
h38 c, h7C c, h44 c, h44 c, h6C c, h28 c, h00 c, h00 c,
h30 c, h78 c, h48 c, h49 c, h3F c, h7F c, h40 c, h00 c,
h38 c, h7C c, h54 c, h54 c, h5C c, h18 c, h00 c, h00 c,
h48 c, h7E c, h7F c, h49 c, h03 c, h02 c, h00 c, h00 c,
h98 c, hBC c, hA4 c, hA4 c, hF8 c, h7C c, h04 c, h00 c,
h41 c, h7F c, h7F c, h08 c, h04 c, h7C c, h78 c, h00 c,
h00 c, h44 c, h7D c, h7D c, h40 c, h00 c, h00 c, h00 c,
h60 c, hE0 c, h80 c, h80 c, hFD c, h7D c, h00 c, h00 c,
h41 c, h7F c, h7F c, h10 c, h38 c, h6C c, h44 c, h00 c,
h00 c, h41 c, h7F c, h7F c, h40 c, h00 c, h00 c, h00 c,
h7C c, h7C c, h08 c, h38 c, h0C c, h7C c, h78 c, h00 c,
h7C c, h7C c, h04 c, h04 c, h7C c, h78 c, h00 c, h00 c,
h38 c, h7C c, h44 c, h44 c, h7C c, h38 c, h00 c, h00 c,
h84 c, hFC c, hF8 c, hA4 c, h24 c, h3C c, h18 c, h00 c,
h18 c, h3C c, h24 c, hA4 c, hF8 c, hFC c, h84 c, h00 c,
h44 c, h7C c, h78 c, h4C c, h04 c, h1C c, h18 c, h00 c,
h48 c, h5C c, h54 c, h54 c, h74 c, h24 c, h00 c, h00 c,
h00 c, h04 c, h3E c, h7F c, h44 c, h24 c, h00 c, h00 c,
h3C c, h7C c, h40 c, h40 c, h3C c, h7C c, h40 c, h00 c,
h1C c, h3C c, h60 c, h60 c, h3C c, h1C c, h00 c, h00 c,
h3C c, h7C c, h60 c, h38 c, h60 c, h7C c, h3C c, h00 c,
h44 c, h6C c, h38 c, h10 c, h38 c, h6C c, h44 c, h00 c,
h9C c, hBC c, hA0 c, hA0 c, hFC c, h7C c, h00 c, h00 c,
h4C c, h64 c, h74 c, h5C c, h4C c, h64 c, h00 c, h00 c,
h08 c, h08 c, h3E c, h77 c, h41 c, h41 c, h00 c, h00 c,
h00 c, h00 c, h7F c, h7F c, h00 c, h00 c, h00 c, h00 c,
h41 c, h41 c, h77 c, h3E c, h08 c, h08 c, h00 c, h00 c,
h02 c, h03 c, h01 c, h03 c, h02 c, h03 c, h01 c, h00 c,
h4C c, h5E c, h73 c, h01 c, h73 c, h5E c, h4C c, h00 c,
Font d768 + wconstant Font_end

\ =========================================================================== 
\ Main 
\ =========================================================================== 
\ Set matrix buffer's value(1word) into outa-register 
\ ( n1 -- n2 )  n1:address of matrix buffer  n2:n1+2
lockdict create a_matrix_32x64 forthentry
$C_a_lxasm w, h119  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WiPZB l, z1SyLI[ l, z4ixZB l, z1bixZC l, z20yPO2 l, z1SV01X l,
freedict

\ Set [D C B A] to matrix buffer
\ ( -- )
: prepMatrix
here W@
2 0 do
     d16 0 do                             \ from 1st line to 16th line
          d64 0 do                      \ from bit0 to bit63
               j LnA lshift             \ Get line number
               en_m or                  \ En=1 clk=0 LE=0 
               over W!                  \ Save line number to each dot
               2+                       \ next address
          loop
     loop
loop
drop
;

\ Set port to output
\ ( -- )
: setPort R1 d13 0 do dup pinout 1+ loop drop ;

\ Display matrix buffer's value to LED-Matrix
\ ( -- )
: scanMatrix
setPort
here W@                            \ Address for matrix buffer
begin
     dup
     2 0 do
          d16 0 do
               d64 0 do
                    clk_m a_matrix_32x64
               loop
               LE pinhi LE pinlo     
               EN pinlo
          loop
     loop
     drop
\     fkey? swap drop     
\ until
0 until
\ drop
;

\ Clear color-bit in matrix_buffer
\ ( -- )
: clrMatrix
h3F R1 lshift invert here W@       \ ( color_mask matrix_buffer_address )
d4096 0 do
     2dup
     dup W@ rot and swap W!        \ Clear color
2 +loop
2drop
;

\ Shift 1line[63bit] to 1bit left  (b63[address]<--b62[address+2]..b1<--b0)
\ ( n1 -- n2 ) n1:Top address of 1line  n2:Top address of 1line
: shift63
d63 0 do
     dup dup 2+                    \ ( addr addr addr+2 )  
     W@ swap W!                    \ ( addr )
     2+                            \ ( addr+2 )
loop
2+
;

\ Shift 16 line to 1bit left  ([address]<--[address+2])
\ ( n1 -- ) n1:matrix address
: shift8x63 8 0 do shift63 loop drop ;  

\ Check H/W
\ ( -- )
: test
prepMatrix
c" scanMatrix" 0 cogx

d4096 0 do
     i d2048 < if 7 R1 else 7 R2 then lshift 
     here W@ i + W@ or here W@ i + W!
     d50 delms 
2 +loop      
0 cogreset
;

\ Get top address for code
\ ( n1 -- n2 ) n1:char code  n2:top address of font table
: topAddrFont h20 - 8 * Font + ;

\ Save coloe-data to b0-position
\ ( n1 n2 n3 -- ) n1:color n2:top address of A-plane or B-plane n3:row number
: saveColorUpper d128 * + d126 + swap over W@ upper_m and or swap W! ;
: saveColorLower d128 * + d126 + swap over W@ lower_m and or swap W! ;

\ Get next char code
\ ( n1 -- n2 ) n1:char code n2:next char code
: nextChar 1+ dup d128 = if drop h20 then ;

\ Get next color
\ ( n1 -- n2 ) n1:color n2:next color
: nextColor 1+ 7 and dup 0= if drop 1 then ;

\ Display character on A-plane
\ ( -- )  
: dispCharA
\ Shift bit
here W@ shift8x63
\ Save color-data on b0-row
charA W@ topAddrFont nA W@ + C@         \ Get char-byte on each row 
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorA W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R1 lshift                                      
     here W@ i saveColorUpper           \ ( row_data )
loop                             
drop
\ Increment nA, Back to spdA
nA W@ 1+ nA W! spdA W@ sftspdA W! 
\ Update charA,sftspdA
nA W@ 7 = 
if 
     charA W@ nextChar charA W!
     colorA W@ nextColor colorA W!
     0 nA W!
then
;

\ Display character on B-plane
\ ( -- )  
: dispCharB
\ Shift bit
here W@ d1024 + shift8x63
\ Save color-data on b0-row
charB W@ topAddrFont nB W@ + C@         \ Get char-byte on each row   
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorB W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R1 lshift                                      
     here W@ d1024 + i saveColorUpper   \ ( row_data )              
loop                             
drop
\ Increment nA, Back to spdA
nB W@ 1+ nB W! spdB W@ sftspdB W! 
\ Update charA,sftspdA
nB W@ 7 = 
if 
     charB W@ nextChar charB W!
     colorB W@ nextColor colorB W!
     0 nB W!
then
;

\ Display character on C-plane
\ ( -- )  
: dispCharC
\ Shift bit
here W@ d2048 + shift8x63
\ Save color-data on b0-row
charC W@ topAddrFont nC W@ + C@         \ Get char-byte on each row  
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorC W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R2 lshift                                      
     here W@ d2048 + i saveColorLower   \ ( row_data )
loop                             
drop
\ Increment nA, Back to spdA
nC W@ 1+ nC W! spdC W@ sftspdC W! 
\ Update charA,sftspdA
nC W@ 7 = 
if 
     charC W@ nextChar charC W!
     colorC W@ nextColor colorC W!
     0 nC W!
then
;

\ Display character on B-plane
\ ( -- )  
: dispCharD
\ Shift bit
here W@ d3072 + shift8x63
\ Save color-data on b0-row
charD W@ topAddrFont nD W@ + C@         \ Get char-byte on each row  
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorD W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R2 lshift                                      
     here W@ d3072 + i saveColorLower   \ ( row_data )
loop                             
drop
\ Increment nA, Back to spdA
nD W@ 1+ nD W! spdD W@ sftspdD W! 
\ Update charA,sftspdA
nD W@ 7 = 
if 
     charD W@ nextChar charD W!
     colorD W@ nextColor colorD W!
     0 nD W!
then
;

\ Initialize display 8x8font
\ ( -- )
: init8x8
prepMatrix
c" scanMatrix" 0 cogx
h20 charA W! h20 charB W! h20 charC W! h20 charD W!
1 colorA W! 1 colorB W! 1 colorC W! 1 colorD W!
0 nA W! 0 nB W! 0 nC W! 0 nD W!
0 spdA W! 0 spdB W! 0 spdC W! 0 spdD W! 
;

\ Display 8x8characters[h20-h7F] on 4 plane
\ ( -- )  
: dispChar8x8
init8x8

begin                            
     \ PlaneA
     sftspdA W@ 0=
     if
          dispCharA
     else
          sftspdA W@ 1- sftspdA W!     
     then
                     
     \ PlaneB
     sftspdB W@ 0=
     if
          dispCharB
     else
          sftspdB W@ 1- sftspdB W!     
     then
                
     \ PlaneC
     sftspdC W@ 0=
     if
          dispCharC
     else
          sftspdC W@ 1- sftspdC W!     
     then

     \ PlaneD
     sftspdD W@ 0=
     if
          dispCharD
     else
          sftspdD W@ 1- sftspdD W!     
     then
\     fkey? swap drop
0 until
\ 0 cogreset
;

\ Set cstr in StrStruct for each plane
\ ( n1 n2 -- ) n1:cstr n2:plane[0,1,2,3]
: setStr
d34 * >r 
C@++ dup                                \ ( c-addr+1 c1 c1 )
dup d32 > if 2drop d26 d26 then         \ Set 26 if length exceed 26
r> StrStruct + dup >r W!                \ Save string length
bounds r> 2+ rot2                \ Save string
do dup i C@ swap C! 1+ loop
drop 
;
     
\ Get character from string
\ ( n1 n2 -- n3 n4 )   n1:current number n2:strStruct address  n3:new current number n4:charcter code
: getChar
2dup W@ =                                
if                        
     nip                                \ ( addr ) 
     1 swap                             \ ( 1 addr )
else
     over 1+ rot2 +                     \ ( n1+1 addr+n1 ) 
then                          
2+ C@                                   \ Get next character in string
;

\ Display 8x8string on A-plane
\ ( -- )  
: dispStrA
\ Shift bit
here W@ shift8x63                    
\ Save color-data on b0-row
charA W@ topAddrFont nA W@ + C@         \ Get char-byte on each row 
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorA W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R1 lshift                                      
     here W@ i saveColorUpper           \ ( row_data )
loop                             
drop                                        
\ Increment nA, Back to spdA
nA W@ 1+ nA W! spdA W@ sftspdA W! 
\ Update charA,sftspdA
nA W@ 7 = 
if 
     currenttNumA W@ StrStruct getChar charA W! currenttNumA W!
     colorA W@ nextColor colorA W!
     0 nA W!
then                                   
;

\ Display 8x8string on B-plane
\ ( -- )  
: dispStrB
\ Shift bit
here W@ d1024 + shift8x63                    
\ Save color-data on b0-row
charB W@ topAddrFont nB W@ + C@         \ Get char-byte on each row 
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorB W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R1 lshift                                      
     here W@ d1024 + i saveColorUpper   \ ( row_data )
loop                             
drop                                        
\ Increment nB, Back to spdB
nB W@ 1+ nB W! spdB W@ sftspdB W! 
\ Update charB,sftspdB
nB W@ 7 = 
if 
     currenttNumB W@ StrStruct d34 + getChar charB W! currenttNumB W!
     colorB W@ nextColor colorB W!
     0 nB W!
then                                   
;

\ Display 8x8string on C-plane
\ ( n1 -- )  n1:top address for C plane
: dispStrC
\ Shift bit
here W@ d2048 + shift8x63                    
\ Save color-data on b0-row
charC W@ topAddrFont nC W@ + C@         \ Get char-byte on each row 
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorC W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R2 lshift                                      
     here W@ d2048 + i saveColorLower   \ ( row_data )
loop                             
drop                                        
\ Increment nC, Back to spdC
nC W@ 1+ nC W! spdC W@ sftspdC W! 
\ Update charC,sftspdC
nC W@ 7 = 
if 
     currenttNumC W@ StrStruct d68 + getChar charC W! currenttNumC W!
     colorC W@ nextColor colorC W!
     0 nC W!
then                                   
;

\ Display 8x8string on D-plane
\ ( n1 -- )  n1:top address for D plane
: dispStrD
\ Shift bit
here W@ d3072 + shift8x63                    
\ Save color-data on b0-row
charD W@ topAddrFont nD W@ + C@         \ Get char-byte on each row 
8 0 do                                  \ from 1st row to 8th row(each bit row)
     dup                                \ ( row_data row_data )
     1 i lshift and                     \ ( row_data 1/0 )
     if colorD W@ 7 and else 0 then     \ ( row_data colorA/0 ) Selection color
     R2 lshift                                      
     here W@ d3072 + i saveColorLower   \ ( row_data )
loop                             
drop                                        
\ Increment nA, Back to spdA
nD W@ 1+ nD W! spdD W@ sftspdD W! 
\ Update charD,sftspdD
nD W@ 7 = 
if 
     currenttNumD W@ StrStruct d102 + getChar charD W! currenttNumD W!
     colorD W@ nextColor colorD W!
     0 nD W!
then                                   
;


{
fl                                                                                                       
\ ( n1 n2 -- n3 )  n1:address of buffer n2:clk_m  n3:n1+2
build_BootOpt :rasm
          mov       $C_treg1 , $C_stTOS
          spop   
          rdword    outa , $C_stTOS
          or        outa , $C_treg1
          add       $C_stTOS , # 2
          jexit
          
;asm a_matrix_32x64

}
